<?php
header('Content-type: image/png');
$sEyes = isset($_GET["eyes"]) ? $_GET["eyes"] : "normal";
$aEyeTypes = array("normal"=>1, "angry"=>2, "hurt"=>3, "happy"=>4, "dead"=>5, "surprise"=>6, "surprised"=>6, "none"=>0, "black"=>7, "blink"=>3);
$iEye = $aEyeTypes[$sEyes];

$sImage = "default.png";
if(!file_exists($sImage)) {
	echo "skin not found";
	exit;
}


// set all image variables
$imageSkin = image::loadPng($sImage);
$imageAvatee = image::createtransparent(96, 96);

$imageBlackBody = image::createtransparent(96, 96);
$imageColorBody = image::createtransparent(96, 96);

$imageBlackFeet = image::createtransparent(64, 32);
$imageColorFeet = image::createtransparent(64, 32);

$imageEyeLeft = image::createtransparent(32, 32);
$imageEyeRight = image::createtransparent(32, 32);

//load all images
imagecopy($imageBlackBody, $imageSkin, 0, 0, 96, 0, 96, 96); // black body
imagecopy($imageColorBody, $imageSkin, 0, 0, 0, 0, 96, 96); // color body
if(isset($_GET["br"]) && isset($_GET["bg"]) && isset($_GET["bb"]))
	self::colorate($imageColorBody, $_GET["br"], $_GET["bg"], $_GET["bb"]);

imagecopy($imageBlackFeet, $imageSkin, 0, 0, 192, 64, 64, 32); // black feet
imagecopy($imageColorFeet, $imageSkin, 0, 0, 192, 32, 64, 32); // color feet
if(isset($_GET["fr"]) && isset($_GET["fg"]) && isset($_GET["fb"]))
	self::colorate($imageColorFeet, $_GET["fr"], $_GET["fg"], $_GET["fb"]);

imagecopy($imageEyeLeft, $imageSkin, 0, 0, 32 + 32 * $iEye, 96, 32, 32); // left eye
imagecopy($imageEyeRight, $imageSkin, 0, 0, 32 + 32 * $iEye, 96, 32, 32); // right eye
image::flip($imageEyeRight, 1);

//set rendering
imagecopy($imageAvatee, $imageBlackBody, 0, 0, 0, 0, 96, 96); // black body
imagecopy($imageAvatee, $imageBlackFeet, 5, 58, 0, 0, 64, 32); // left black feet
imagecopy($imageAvatee, $imageBlackFeet, 25, 58, 0, 0, 64, 32); // right black feet

imagecopy($imageAvatee, $imageColorFeet, 25, 58, 0, 0, 64, 32); // right feet
imagecopy($imageAvatee, $imageColorBody, 0, 0, 0, 0, 96, 96); // body
imagecopy($imageAvatee, $imageColorFeet, 5, 58, 0, 0, 64, 32); // left feet

imagecopy($imageAvatee, $imageEyeLeft, 26, 32, 0, 0, 32, 32); // left eye
imagecopy($imageAvatee, $imageEyeRight, 38, 32, 0, 0, 32, 32); // right eye

// final draw
imagepng($imageAvatee);

// clear
image::clear(array($imageSkin, $imageAvatee, $imageBlackBody, $imageColorBody,
					$imageBlackFeet, $imageColorFeet, $imageEyeLeft, $imageEyeRight));


// thanks to MAP94 for this function
function colorate(&$im, $cr, $cg, $cb) {
	$w = imagesx($im);
	$h = imagesy($im);

	imagealphablending($im, false);

	for($x = 0; $x < $w; $x++) {
		for($y = 0; $y < $h; $y++) {
			$col = imagecolorat($im, $x, $y);
			$a = ($col & 0x7F000000) >> 24;
			$r = ($col >> 16) & 0xFF;
			$g = ($col >> 8) & 0xFF;
			$b = $col & 0xFF;
			$gray = $r * 0.3 + $g * 0.59 + $b * 0.11;


			$r = self::mix($gray, $cr);
			$g = self::mix($gray, $cg);
			$b = self::mix($gray, $cb);

			imagesetpixel($im, $x, $y, imagecolorallocatealpha($im, $r, $g, $b, $a));
		}
	}
}

function mix($a, $b) {
	return $a * $b / 255;
}

class image
{
    public static function flip (&$img, $mode)
    {
        $w = imagesx($img);
        $h = imagesy($img);

        $srcX = 0;
        $srcY= 0;
        $srcW = $w;
        $srcH = $h;

        switch ($mode) {
            case 0: //vertical
                $srcY = $h -1;
                $srcH = -$h;
                break;
            case 1: //horizontal
                $srcX = $w - 1;
                $srcW = -$w;
                break;
            case 2: //both
                $srcY = $h -1;
                $srcH = -$h;
                $srcX = $w - 1;
                $srcW = -$w;
                break;
            default:
                return;
        }

        $dest = self::createtransparent($w, $h);

        if(imagecopyresampled ($dest, $img, 0, 0, $srcX, $srcY , $w, $h, $srcW, $srcH)) {
            $img = $dest;
        }
    }

    public static function createtransparent($w, $h)
    {
        $img = imagecreatetruecolor($w, $h);
        imagesavealpha($img, true);
        imagealphablending($img, true);
        $trans = imagecolorallocatealpha($img, 0, 0, 0, 127);
        imagefill($img, 0, 0, $trans);
        return $img;
    }

    public static function loadPng($imgsrc)
    {
        $img = imagecreatefrompng($imgsrc);
        imagesavealpha($img, true);
        imagealphablending($img, true);
        return $img;
    }

    public static function clear($images)
    {
        foreach($images as $image) {
            imagedestroy($image);
        }
    }
}